## Index

### Enumerations

- Orientation

### Classes

- Page
- Patch
- Router

### Interfaces

- FrameworkOptions
- HideEventData
- IBackButtonEventListener
- ICommandListener
- IOrientationChangedListener
- IPage
- InitOptions
- Intent
- JQuerySettings
- ManagedIntent
- NavigateInfo
- NavigateOptions
- OrientationListenerHolder
- PageConstructOptions
- PageStack
- PlainSettings
- RouteContext
- RouterOptions
- ShowEventData
- SubFlowParam
- SubFlowParamEx

### Type aliases

- Collection
- Events
- Model
- ModelDestroyOptions
- ModelFetchOptions
- ModelSaveOptions
- ModelSetOptions
- PageTransitionDirection
- View
- ViewOptions

### Variables

- Platform
- TAG
- _activePage
- _defaultBeforeRouteChange
- _dfInitialize
- _lastOrientation
- _orientationListenerHolder
- _pageConstructors
- _pageInstances

### Functions

- _apply_jqm_popup_createPrerequisites
- _apply_jqm_popup_handleWindowResize
- _beforeRouteChange
- _mobilePopupPatch
- _setActivePage
- _setupEventHandlers
- _vclickPatch
- constructPages
- disposePages
- getConfig
- getCurrentDocumentUrl
- getDefaultClickEvent
- getOrientation
- initialize
- isInitialized
- registerOrientationChangedListener
- registerPage
- setBeforeRouteChangeHandler
- toUrl
- unregisterOrientationChangedListener
- waitForInitialize

## Type aliases

### Collection

Collection: Collection<TModel> = Backbone.Collection

- Defined in Interfaces.ts:8
- Defined in Interfaces.ts:9

### Events

Events: Events = Backbone.Events

- Defined in Interfaces.ts:12
- Defined in Interfaces.ts:13

### Model

Model: Model = Backbone.Model

- Defined in Interfaces.ts:6
- Defined in Interfaces.ts:7

### ModelDestroyOptions

ModelDestroyOptions: ModelDestroyOptions

- Defined in Interfaces.ts:17

### ModelFetchOptions

ModelFetchOptions: ModelFetchOptions

- Defined in Interfaces.ts:15

### ModelSaveOptions

ModelSaveOptions: ModelSaveOptions

- Defined in Interfaces.ts:16

### ModelSetOptions

ModelSetOptions: ModelSetOptions

- Defined in Interfaces.ts:14

### PageTransitionDirection

PageTransitionDirection: "back" | "forward" | "same" | "unknown"

- Defined in Interfaces.ts:24

en

  direction definitions.

ja

  遷移方向の定義.

### View

View: View<TModel> = Backbone.View

- Defined in Interfaces.ts:10
- Defined in Interfaces.ts:11

### ViewOptions

ViewOptions: ViewOptions<TModel>

- Defined in Interfaces.ts:18

## Variables

### Platform

Platform: object = (() => {const ua = navigator.userAgent.toLowerCase();const majorVersion = function (browser: string): number {const version = ua.match(new RegExp("(" + browser + ")( |/)([0-9]+)"));if (!version || version.length < 4) {return 0;}return parseInt(version[3], 10);};return {ltIE6: typeof window.addEventListener === "undefined" && typeof (<any>document.documentElement).style.maxHeight === "undefined",ltIE7: typeof window.addEventListener === "undefined" && typeof document.querySelectorAll === "undefined",ltIE8: typeof window.addEventListener === "undefined" && typeof document.getElementsByClassName === "undefined",ltIE9: (<any>document).uniqueID && typeof window.matchMedia === "undefined",gtIE10: (<any>document).uniqueID && window.matchMedia,Trident: (<any>document).uniqueID,Gecko: "MozAppearance" in (<any>document.documentElement).style,Presto: global.opera,Blink: global.chrome,Webkit: typeof global.chrome === "undefined" && "WebkitAppearance" in (<any>document.documentElement).style,Touch: typeof global.ontouchstart !== "undefined",Mobile: (typeof global.orientation !== "undefined") || (ua.indexOf("Windows Phone") !== -1),ltAd4_4: typeof global.orientation !== "undefined" && (typeof global.EventSource === "undefined" || 30 > majorVersion("chrome")),Pointer: global.navigator.pointerEnabled,MSPoniter: global.navigator.msPointerEnabled,Android: (ua.indexOf("android") !== -1),iOS: (ua.indexOf("iphone") !== -1 || ua.indexOf("ipad") !== -1 || ua.indexOf("ipod") !== -1),};})()

- Defined in Platform.ts:11

en

  platform judgement utility

ja

  platform 判定オブジェクト

seehttps://w3g.jp/blog/tools/js_browser_sniffing

#### Type declaration

- ##### Android: boolean

- ##### Blink: any

- ##### Gecko: boolean

- ##### MSPoniter: any

- ##### Mobile: boolean

- ##### Pointer: any

- ##### Presto: any

- ##### Touch: boolean

- ##### Trident: any

- ##### Webkit: boolean

- ##### gtIE10: matchMedia

- ##### iOS: boolean

- ##### ltAd4_4: boolean

- ##### ltIE6: boolean

- ##### ltIE7: boolean

- ##### ltIE8: boolean

- ##### ltIE9: boolean

### TAG

TAG: "[CDP.Framework.Router] " = "[CDP.Framework.Router] "

- Defined in CoreAPI.ts:109
- Defined in Page.ts:5
- Defined in Router.ts:8

### _activePage

_activePage: IPage = null

- Defined in CoreAPI.ts:254

### _defaultBeforeRouteChange

_defaultBeforeRouteChange: _beforeRouteChange = _beforeRouteChange

- Defined in Router.ts:68

### _dfInitialize

_dfInitialize: JQueryDeferred<void> = $.Deferred<void>()

- Defined in CoreAPI.ts:111

### _lastOrientation

_lastOrientation: Orientation = null

- Defined in CoreAPI.ts:288

### _orientationListenerHolder

_orientationListenerHolder: OrientationListenerHolder

- Defined in CoreAPI.ts:225

### _pageConstructors

_pageConstructors: object[] = []

- Defined in CoreAPI.ts:313

### _pageInstances

_pageInstances: IPage[] = []

- Defined in CoreAPI.ts:314

## Functions

### _apply_jqm_popup_createPrerequisites

- _apply_jqm_popup_createPrerequisites(): void

- - Defined in Patch.ts:37

  $.mobile.widget.popup patch for "_createPrerequisites"

  patch code from jqm 1.5 https://github.com/jquery/jquery-mobile/commit/d34c86ae14d4ea603357be5e326de1fb8c31dbf9

  #### Returns void

### _apply_jqm_popup_handleWindowResize

- _apply_jqm_popup_handleWindowResize(): void

- - Defined in Patch.ts:81

  $.mobile.widget.popup patch for "_handleWindowResize"

  patch code from stack overflow https://stackoverflow.com/questions/27090445/jqmobile-re-positions-popup-window-every-time-when-android-opens-own-virtual-key

  #### Returns void

### _beforeRouteChange

- _beforeRouteChange(): IPromiseBase<any>

- - Defined in Router.ts:63

  #### Returns IPromiseBase<any>

### _mobilePopupPatch

- _mobilePopupPatch(): void

- - Defined in Patch.ts:106

  $.mobile.widget.popup patch

  #### Returns void

### _setActivePage

- _setActivePage(page: IPage): void

- - Defined in CoreAPI.ts:296
  en

    Setup active IPage instance.

  ja

    active Page の設定. Framework がコールする.

  internal

  #### Parameters

  - ##### page: IPage

  #### Returns void

### _setupEventHandlers

- _setupEventHandlers(): void

- - Defined in CoreAPI.ts:262
  en

    Setup event handlers when after router initialized.

  ja

    イベントハンドラの設定. Router 初期化後に Framework がコールする.

  internal

  #### Returns void

### _vclickPatch

- _vclickPatch(): void

- - Defined in Patch.ts:8

  vclick patch

  #### Returns void

### constructPages

- constructPages(): void

- - Defined in CoreAPI.ts:334
  en

    Page instances are generated from the reserved constructor.

  ja

    予約されたコンストラクタからPage インスタンスを生成

  #### Returns void

### disposePages

- disposePages(): void

- - Defined in CoreAPI.ts:345
  en

    Release Page instance reference

  ja

    Page インスタンスの参照を破棄

  #### Returns void

### getConfig

- getConfig(options: FrameworkOptions): FrameworkOptions

- - Defined in CoreAPI.ts:355
  en

    Get Config object.

  ja

    Config object の取得

  internal

  #### Parameters

  - ##### options: FrameworkOptions

  #### Returns FrameworkOptions

### getCurrentDocumentUrl

- getCurrentDocumentUrl(): string

- - Defined in Router.ts:41
  en

    Get current document url.

  ja

    現在表示しているドキュメントの URL を取得

  internal

  #### Returns string

### getDefaultClickEvent

- getDefaultClickEvent(): string

- - Defined in CoreAPI.ts:309
  en

    Reterns framework default click event string.

  ja

    Framework が既定に使用するクリックイベント文字列を取得

  #### Returns string

  "vclick" / "click"

### getOrientation

- getOrientation(): Orientation

- - Defined in Orientation.ts:16
  en

    Get Orientation enum code

  ja

    Orientation の取得

  #### Returns Orientation

### initialize

- initialize(options?: FrameworkOptions): IPromiseBase<void>

- - Defined in CoreAPI.ts:117
  en

    Initialization function of Framework.

  ja

    Framework の初期化関数

  #### Parameters

  - ##### Optional options: FrameworkOptions

  #### Returns IPromiseBase<void>

### isInitialized

- isInitialized(): boolean

- - Defined in CoreAPI.ts:213
  en

    Check for initialization status.

  ja

    初期化済みか判定

  #### Returns boolean

  - `en` true: initialized / false: uninitialized
  - `ja` true: 初期化済み / false: 未初期化

### registerOrientationChangedListener

- registerOrientationChangedListener(key: string, listener: IOrientationChangedListener): void

- - Defined in CoreAPI.ts:238
  en

    Register IOrientationChangedListener to framework.

  ja

    IOrientationChangedListener を Framework に登録

  #### Parameters

  - ##### key: string

    - `en` ID key
    - `ja` クライアントで管理可能な ID

  - ##### listener: IOrientationChangedListener

    - `en` IOrientationChangedListener instance
    - `ja` IOrientationChangedListener インスタンス

  #### Returns void

### registerPage

- registerPage(ctor: object): void

- - Defined in CoreAPI.ts:326
  en

    Register Concrete IPage class.
    If constructor needs arguments, use bind() function.

  ja

    Page の登録
    constructor を指定する. 引数がある場合は、bind を行うこと

  #### Parameters

  - ##### ctor: object

    - `en` Concrete IPage class constructor
    - `ja` コンストラクタを指定

  #### Returns void

### setBeforeRouteChangeHandler

- setBeforeRouteChangeHandler(handler: function): function

- - Defined in Router.ts:83
  en

    Setup "before route change" handler.

  ja

    "before route change" ハンドラ設定

  internal

  #### Parameters

  - ##### handler: function

    - - (): IPromiseBase<any>

      - #### Returns IPromiseBase<any>

  #### Returns function

  - `en` old handler function.
  - `ja` 以前の handler.
  - - (): IPromiseBase<any>
    - - `en` handler function.
      - `ja` handler 指定.

      #### Returns IPromiseBase<any>

### toUrl

- toUrl(path: string): string

- - Defined in Router.ts:27
  en

    Convert path to URL.
    If the path starts from "/", the function translate the path as child folder of "web root".
    Otherwise, it interprets as relative path from current page.
    [Note] This behavior go along with jQM, NOT with require.toUrl().

  ja

    path を URL に変換
    "/" から始まるものは web root から、それ以外は現在のページから絶対パスURLに変換する。
    jQM の挙動にあわせており、require.toUrl() と異なるので注意。

  #### Parameters

  - ##### path: string

    - `en` set relative path from [[webRoot]], or relative path from current scirpt owner html (It doesn't start from "/").
    - `ja` [[webRoot]] からの相対パス, もしくはカレントスクリプトを走らせている HTML からの相対パス ("/" なし).

  #### Returns string

### unregisterOrientationChangedListener

- unregisterOrientationChangedListener(key: string): void

- - Defined in CoreAPI.ts:250
  en

    Unregister IOrientationChangedListener from framework.

  ja

    IOrientationChangedListener を Framework から登録解除

  #### Parameters

  - ##### key: string

    - `en` ID key by using register
    - `ja` 登録時に使用した ID

  #### Returns void

### waitForInitialize

- waitForInitialize(): IPromiseBase<void>

- - Defined in CoreAPI.ts:221
  en

    Wait for initialization status.

  ja

    初期化待ち

  #### Returns IPromiseBase<void>

Generated using TypeDoc